Index: java/main/src/main/java/com/framsticks/remote/RemoteTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 97)
@@ -0,0 +1,397 @@
+package com.framsticks.remote;
+
+import com.framsticks.communication.*;
+import com.framsticks.communication.queries.CallRequest;
+import com.framsticks.communication.queries.GetRequest;
+import com.framsticks.communication.queries.InfoRequest;
+import com.framsticks.communication.queries.SetRequest;
+import com.framsticks.core.AbstractTree;
+import com.framsticks.core.Mode;
+import com.framsticks.core.TreeOperations;
+import com.framsticks.core.ListChange;
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.params.*;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.core.Tree;
+import com.framsticks.util.*;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.dispatching.RunAt;
+import static com.framsticks.core.TreeOperations.*;
+
+import java.util.*;
+
+import javax.annotation.Nonnull;
+
+import org.apache.log4j.Logger;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@FramsClassAnnotation
+public class RemoteTree extends AbstractTree implements JoinableParent {
+
+	private final static Logger log = Logger.getLogger(RemoteTree.class);
+
+	protected ClientSideManagedConnection connection;
+
+	protected final Set<Pair<Path, Subscription<?>>> subscriptions = new HashSet<>();
+
+	public Pair<Path, Subscription<?>> getSubscription(Path path) {
+		for (Pair<Path, Subscription<?>> s : subscriptions) {
+			if (s.first.matches(path)) {
+				return s;
+			}
+		}
+		return null;
+	}
+
+	public RemoteTree() {
+	}
+
+	@ParamAnnotation
+	public void setAddress(String address) {
+		setConnection(Connection.to(new ClientSideManagedConnection(), new Address(address)));
+	}
+
+	@ParamAnnotation
+	public String getAddress() {
+		return connection == null ? "<disconnected>" : connection.getAddress().toString();
+	}
+
+	@AutoAppendAnnotation
+	public void setConnection(final ClientSideManagedConnection connection) {
+		this.connection = connection;
+		// final ExceptionResultHandler failure = new ExceptionResultHandler() {
+		// 	@Override
+		// 	public void handle(FramsticksException exception) {
+		// 		log.fatal("failed to establish connection: ", exception);
+		// 		// log.fatal("unsupported protocol version!\n minimal version is: " + "\nmanager protocol is: " + connection.getProtocolVersion());
+		// 		Dispatching.drop(connection, RemoteTree.this);
+		// 		fireRun(exception);
+		// 	}
+		// };
+
+	}
+
+	@Override
+	public String toString() {
+		assert Dispatching.isThreadSafe();
+		return "remote tree " + getName() + "(" + getAddress() + ")";
+	}
+
+	public final ClientSideManagedConnection getConnection() {
+		return connection;
+	}
+
+	@Override
+	public void get(final Path path, final PrimitiveParam<?> param, Mode mode, final Future<Object> future) {
+		assert isActive();
+		assert param != null;
+		assert path.isResolved();
+		//TODO only do that if needed
+		connection.send(new GetRequest().field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(future) {
+			@Override
+			protected void processOk(Response response) {
+				assert isActive();
+				TreeOperations.processFetchedValues(path, response.getFiles());
+				future.pass(bindAccess(path).get(param, Object.class));
+			}
+		});
+	}
+
+	protected final Map<String, Set<Future<FramsClass>>> infoRequests = new HashMap<String, Set<Future<FramsClass>>>();
+
+
+	@Override
+	public void info(final Path path, final Future<FramsClass> future) {
+
+		final String name = path.getTop().getParam().getContainedTypeName();
+
+		if (infoRequests.containsKey(name)) {
+			infoRequests.get(name).add(future);
+			return;
+		}
+
+		log.debug("issuing info request for " + name);
+		final Set<Future<FramsClass>> futures = new HashSet<Future<FramsClass>>();
+		futures.add(future);
+		infoRequests.put(name, futures);
+
+		final Future<FramsClass> compositeFuture = new Future<FramsClass>() {
+
+			@Override
+			public void handle(FramsticksException exception) {
+				assert isActive();
+				infoRequests.remove(name);
+				for (Future<FramsClass> f : futures) {
+					f.handle(exception);
+				}
+			}
+
+			@Override
+			protected void result(FramsClass framsClass) {
+				assert isActive();
+				infoRequests.remove(name);
+				for (Future<FramsClass> f : futures) {
+					f.pass(framsClass);
+				}
+			}
+		};
+
+		//TODO: if the info is in the cache, then don't communicate
+		connection.send(new InfoRequest().path(path.getTextual()), this, new ClientSideResponseFuture(compositeFuture) {
+			@Override
+			protected void processOk(Response response) {
+				assert isActive();
+
+				if (response.getFiles().size() != 1) {
+					throw new FramsticksException().msg("invalid number of files in response").arg("files", response.getFiles().size());
+				}
+				if (!path.isTheSame(response.getFiles().get(0).getPath())) {
+					throw new FramsticksException().msg("path mismatch").arg("returned path", response.getFiles().get(0).getPath());
+				}
+				FramsClass framsClass = TreeOperations.processFetchedInfo(RemoteTree.this, response.getFiles().get(0));
+
+				CompositeParam thisParam = path.getTop().getParam();
+				if (!thisParam.isMatchingContainedName(framsClass.getId())) {
+					throw new FramsticksException().msg("framsclass id mismatch").arg("request", thisParam.getContainedTypeName()).arg("fetched", framsClass.getId());
+				}
+				compositeFuture.pass(framsClass);
+			}
+		});
+	}
+
+	@Override
+	public void get(final Path path, Mode mode, final Future<Object> future) {
+		assert isActive();
+		assert path.getTop().getObject() != null;
+
+		log.trace("fetching values for " + path);
+		connection.send(new GetRequest().path(path.getTextual()), this, new ClientSideResponseFuture(future) {
+			@Override
+			protected void processOk(Response response) {
+				assert isActive();
+				TreeOperations.processFetchedValues(path, response.getFiles());
+				future.pass(path.getTopObject());
+			}
+		});
+	}
+
+	@Override
+	public void resolve(final Path path, final Future<Path> future) {
+		TreeOperations.resolve(path, future);
+	}
+
+	@Override
+	protected void tryRegisterOnChangeEvents(final Path path) {
+		assert isActive();
+		AccessInterface access = TreeOperations.bindAccess(path);
+		if (!(access instanceof ListAccess)) {
+			return;
+		}
+
+		assert path.size() >= 2;
+		FramsClass underFramsClass = getInfoFromCache(path.getUnder().getParam().getContainedTypeName());
+
+		EventParam changedEvent;
+		try {
+			changedEvent = underFramsClass.getParamEntry(path.getTop().getParam().getId() + "_changed", EventParam.class);
+		} catch (FramsticksException e) {
+			return;
+		}
+
+		log.debug("registering for " + changedEvent);
+		if (getSubscription(path) != null) {
+			return;
+		}
+
+		final Pair<Path, Subscription<?>> temporary = new Pair<>(path, null);
+		subscriptions.add(temporary);
+
+		connection.subscribe(path.getTextual() + "_changed", this, new SubscriptionCallback<Tree>() {
+			@Override
+			public EventCallback subscribed(final Subscription<? super Tree> subscription) {
+				if (subscription == null) {
+					log.error("failed to subscribe for change event for " + path);
+					return null;
+				}
+				log.debug("subscribed for change event for " + path);
+				// subscription.setDispatcher(RemoteInstance.this);
+				RemoteTree.this.dispatch(new RunAt<Tree>(this) {
+					@Override
+					protected void runAt() {
+						subscriptions.remove(temporary);
+						subscriptions.add(new Pair<Path, Subscription<?>>(path, subscription));
+					}
+				});
+				return new EventCallback() {
+					@Override
+					public void call(List<File> files) {
+						assert isActive();
+						assert files.size() == 1;
+						final MultiParamLoader loader = new MultiParamLoader();
+						loader.setNewSource(files.get(0).getContent());
+						loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+						loader.addListener(MultiParamLoader.Status.OnComment, new MultiParamLoader.StatusListener() {
+
+							@Override
+							public void onStatusChange() {
+								throw new FramsticksException().msg("multi param loader error").arg("line", loader.getCurrentLine());
+							}
+						});
+						ReflectionAccess access = new ReflectionAccess(ListChange.class, FramsClass.build().forClass(ListChange.class));
+						loader.addAccessInterface(access);
+
+						MultiParamLoader.Status status;
+						while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
+							if (status == MultiParamLoader.Status.AfterObject) {
+								AccessInterface accessInterface = loader.getLastAccessInterface();
+								reactToChange(path, (ListChange) accessInterface.getSelected());
+							}
+						}
+					}
+				};
+			}
+		});
+	}
+
+	protected Future<Path> futureListChanger(final ListChange listChange, final String path) {
+		return new FutureHandler<Path>(Logging.logger(log, "failed to " + listChange, path)) {
+			@Override
+			protected void result(Path result) {
+				log.debug(listChange + ": " + result);
+				fireListChange(result, listChange);
+			}
+		};
+	}
+
+	protected void reactToChange(final Path path, final ListChange listChange) {
+		assert isActive();
+		log.debug("reacting to change " + listChange + " in " + path);
+		AccessInterface access = TreeOperations.bindAccess(path);
+		assert access != null;
+
+		if ((listChange.getAction() == ListChange.Action.Modify) && (listChange.getPosition() == -1)) {
+			final String p = path.getTextual();
+			TreeOperations.resolveAndGet(this, p, futureListChanger(listChange, p));
+			return;
+		}
+
+		CompositeParam childParam = Casting.tryCast(CompositeParam.class, access.getParam(listChange.getBestIdentifier()));
+		assert childParam != null;
+		switch (listChange.getAction()) {
+			case Add: {
+				final String p = path.getTextual() + "/" + childParam.getId();
+				TreeOperations.resolveAndGet(this, p, futureListChanger(listChange, p));
+				break;
+			}
+			case Remove: {
+				access.set(childParam, null);
+				fireListChange(path, listChange);
+				break;
+			}
+			case Modify: {
+				final String p = path.getTextual() + "/" + childParam.getId();
+				TreeOperations.resolveAndGet(this, p, futureListChanger(listChange, p));
+				break;
+			}
+		}
+	}
+
+	@Override
+	public void set(final Path path, final PrimitiveParam<?> param, final Object value, final Future<Integer> future) {
+		assert isActive();
+		final Integer flag = TreeOperations.bindAccess(path).set(param, value);
+
+		log.trace("storing value " + param + " for " + path);
+		//TODO break in passing exception handler is here
+		connection.send(new SetRequest().value(value.toString()).field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(future) {
+			@Override
+			protected void processOk(Response response) {
+				future.pass(flag);
+			}
+		});
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(connection, this);
+		super.joinableStart();
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(connection, this);
+		super.joinableInterrupt();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		super.joinableFinish();
+
+	}
+
+	@Override
+	public void joinableJoin() throws InterruptedException {
+		Dispatching.join(connection);
+		super.joinableJoin();
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+	@Override
+	public void call(@Nonnull final Path path, @Nonnull final ProcedureParam procedure, @Nonnull Object[] arguments, final Future<Object> future) {
+		assert isActive();
+		assert path.isResolved();
+
+		//TODO validate arguments type using params
+		connection.send(new CallRequest().procedure(procedure.getId()).arguments(Arrays.asList(arguments)).path(path.getTextual()), this, new ClientSideResponseFuture(future) {
+			@Override
+			protected void processOk(Response response) {
+				assert isActive();
+				// InstanceUtils.processFetchedValues(path, response.getFiles());
+				future.pass(null);
+			}
+		});
+
+	}
+
+	@Override
+	public Path create(Path path) {
+		assert isActive();
+		assert !path.isResolved();
+		Path resolved = path.tryFindResolution();
+		if (!resolved.isResolved()) {
+			log.debug("creating: " + path);
+			AccessInterface access = registry.prepareAccess(path.getTop().getParam());
+			assert access != null;
+			Object child = access.createAccessee();
+			assert child != null;
+			if (path.size() == 1) {
+				setRoot(new Node(getRoot().getParam(), child));
+			} else {
+				bindAccess(this, path.getUnder()).set(path.getTop().getParam(), child);
+			}
+			resolved = path.appendResolution(child);
+		}
+		tryRegisterOnChangeEvents(resolved);
+		return resolved;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/remote/SimulatorTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/SimulatorTree.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/remote/SimulatorTree.java	(revision 97)
@@ -0,0 +1,118 @@
+package com.framsticks.remote;
+
+import java.util.List;
+
+import org.apache.log4j.Logger;
+
+import static com.framsticks.core.TreeOperations.*;
+import com.framsticks.communication.EventCallback;
+import com.framsticks.communication.File;
+import com.framsticks.communication.util.LoggingSubscriptionCallback;
+import com.framsticks.core.Tree;
+import com.framsticks.core.TreeOperations;
+import com.framsticks.core.Path;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.util.Logging;
+import com.framsticks.util.PeriodicTask;
+import com.framsticks.util.UnaryFunctor;
+import com.framsticks.util.UnaryListenersSet;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+@FramsClassAnnotation
+public class SimulatorTree extends RemoteTree {
+
+	private final static Logger log = Logger.getLogger(SimulatorTree.class);
+
+	protected Path simulator;
+
+	/**
+	 *
+	 */
+	public SimulatorTree() {
+		super();
+	}
+
+	public void setRunning(final boolean running) {
+		assert isActive();
+		//simulator.call(simulator.getParam(running ? "start" : "stop", ProcedureParam.class), new LoggingStateCallback(log, (running ? "starting" : "stopping") + " server"));
+	}
+
+	protected final UnaryListenersSet<Boolean> simulationRunningListeners = new UnaryListenersSet<Boolean>();
+
+	protected void updateSimulationRunning() {
+		assert isActive();
+		/*
+		fetchValue(simulator, getParam(simulator, "running", Param.class), new StateFunctor() {
+			@Override
+			public void call(Exception e) {
+				if (e != null) {
+					log.fatal("failed to query simulator running status: " + e);
+					return;
+				}
+
+				invokeLater(new Runnable() {
+					@Override
+					public void run() {
+						boolean value = bindAccess(simulator).get("running", Boolean.class);
+						log.trace("server running: " + value);
+						simulationRunningListeners.call(value);
+					}
+				});
+
+			}
+		});
+		 */
+	}
+
+	public void addRunningStateListener(UnaryFunctor<Boolean, Boolean> listener) {
+		assert isActive();
+		simulationRunningListeners.add(listener);
+	}
+
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+
+		dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				resolveAndGet(SimulatorTree.this, "/simulator", new FutureHandler<Path>(Logging.logger(log, "failed to resolve simulator node", SimulatorTree.this)) {
+					@Override
+					protected void result(Path path) {
+						assert isActive();
+						simulator = path;
+						fireRun(null);
+						log.info("resolved simulator node");
+
+						EventParam param = TreeOperations.getInfoFromCache(simulator).getParamEntry("running_changed", EventParam.class);
+
+						assert param != null;
+						connection.subscribe(simulator.getTextual() + "/" + param.getId(), SimulatorTree.this, new LoggingSubscriptionCallback<Tree>(log, "server running state change", new EventCallback() {
+							@Override
+							public void call(List<File> files) {
+								//TODO TEH
+								dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+									@Override
+									protected void runAt() {
+										updateSimulationRunning();
+									}
+								});
+							}
+						}));
+						new PeriodicTask<Tree>(ThrowExceptionHandler.getInstance(), SimulatorTree.this, 1000) {
+							@Override
+							protected void runAt() {
+								updateSimulationRunning();
+								again();
+							}
+						};
+					}
+				});
+			}
+		});
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 97)
@@ -26,4 +26,5 @@
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.Thread;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.io.Encoding;
 
@@ -129,8 +130,8 @@
 		}
 
-		readerThread.dispatch(new RunAt<ExternalProcess>() {
+		readerThread.dispatch(new RunAt<ExternalProcess>(ThrowExceptionHandler.getInstance()) {
 
 			@Override
-			public void run() {
+			protected void runAt() {
 				readerTask();
 			}
Index: java/main/src/main/java/com/framsticks/test/TestClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 97)
@@ -1,3 +1,5 @@
 package com.framsticks.test;
+
+import org.apache.log4j.Logger;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -7,7 +9,10 @@
 @FramsClassAnnotation(order = {"name", "history", "appendHistory", "resetHistory"})
 public class TestClass {
+	private static final Logger log =
+		Logger.getLogger(TestClass.class);
+
 
 	protected String name = "test";
-	protected String history = "";
+	protected String history = "initial|";
 
 	/**
@@ -45,4 +50,5 @@
 	@ParamAnnotation(paramType = ProcedureParam.class)
 	public int appendHistory(String line) {
+		log.debug("appending '" + line + "'");
 		history = history + line + "|";
 		return history.length();
@@ -51,4 +57,5 @@
 	@ParamAnnotation(paramType = ProcedureParam.class)
 	public void resetHistory() {
+		log.debug("reseting");
 		history = "";
 	}
Index: java/main/src/main/java/com/framsticks/util/FramsticksException.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 97)
@@ -35,5 +35,5 @@
 	}
 
-	public void getShortMessage(StringBuilder b) {
+	public StringBuilder getShortMessage(StringBuilder b) {
 		if (message != null) {
 			b.append(message);
@@ -50,4 +50,5 @@
 			b.append("(").append(d.build()).append(")");
 		}
+		return b;
 	}
 
Index: java/main/src/main/java/com/framsticks/util/PeriodicTask.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/PeriodicTask.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/PeriodicTask.java	(revision 97)
@@ -2,4 +2,5 @@
 
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Task;
 import com.framsticks.util.dispatching.RunAt;
@@ -13,5 +14,6 @@
 	protected Dispatcher<? super C> dispatcher;
 
-	public PeriodicTask(Dispatcher<? super C> dispatcher, long period) {
+	public PeriodicTask(ExceptionResultHandler handler, Dispatcher<? super C> dispatcher, long period) {
+		super(handler);
 		this.period = period;
 		this.dispatcher = dispatcher;
@@ -21,8 +23,8 @@
 
 	public void again() {
-		dispatcher.dispatch(new Task<C>(period) {
+		dispatcher.dispatch(new Task<C>(handler, period) {
 			@Override
-			public void run() {
-				PeriodicTask.this.run();
+			protected void runAt() {
+				PeriodicTask.this.runAt();
 			}
 		});
Index: java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 97)
@@ -137,5 +137,7 @@
 		boolean start = false;
 		synchronized (this) {
-			assert !owners.contains(owner);
+			if (owners.contains(owner)) {
+				throw new FramsticksException().msg("owner is already using that joinable").arg("joinable", this).arg("owner", owner);
+			}
 			start = owners.isEmpty();
 			log.debug(owner + " is using " + this);
@@ -164,7 +166,7 @@
 		}
 		if (stop) {
-			Dispatching.dispatcherGuardedInvoke(this, new RunAt<Object>() {
+			Dispatching.dispatcherGuardedInvoke(this, new RunAt<Object>(ThrowExceptionHandler.getInstance()) {
 				@Override
-				public void run() {
+				protected void runAt() {
 					interrupt();
 				}
Index: java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 97)
@@ -21,5 +21,5 @@
 	@Override
 	public final void dispatch(RunAt<? extends C> runnable) {
-		runnable.run();
+		runnable.runAt();
 	}
 
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 97)
@@ -4,5 +4,4 @@
 
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.StateFunctor;
 
 /**
@@ -18,18 +17,8 @@
 	public static <C> void dispatchIfNotActive(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
 		if (dispatcher.isActive()) {
-			runnable.run();
+			runnable.runAt();
 			return;
 		}
 		dispatcher.dispatch(runnable);
-	}
-
-	//TODO RunAt StateFunctor
-	public static <C> void dispatchOk(Dispatcher<C> dispatcher, final StateFunctor stateFunctor) {
-		dispatcher.dispatch(new RunAt<C>() {
-			@Override
-			public void run() {
-				stateFunctor.call();
-			}
-		});
 	}
 
@@ -40,7 +29,7 @@
 
 	public static <P, C> void invokeDispatch(Dispatcher<P> dispatcher, final Dispatcher<C> finalDispatcher, final RunAt<C> runnable) {
-		dispatcher.dispatch(new RunAt<P>() {
+		dispatcher.dispatch(new RunAt<P>(runnable) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				finalDispatcher.dispatch(runnable);
 			}
@@ -49,4 +38,5 @@
 
 	public static void sleep(double seconds) {
+		log.debug("sleeping");
 		try {
 			java.lang.Thread.sleep((long) (seconds * 1000));
@@ -54,4 +44,5 @@
 
 		}
+		log.debug("slept");
 	}
 
@@ -62,5 +53,5 @@
 			return;
 		}
-		runnable.run();
+		runnable.runAt();
 	}
 
@@ -95,7 +86,7 @@
 
 	public static void childChangedState(final JoinableParent parent, final Joinable joinable, final JoinableState state) {
-		dispatcherGuardedInvoke(joinable, new RunAt<Object>() {
+		dispatcherGuardedInvoke(joinable, new RunAt<Object>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				log.debug("joinable " + joinable + " is notifying parent " + parent + " about change to " + state);
 				parent.childChangedState(joinable, state);
@@ -140,9 +131,11 @@
 		 */
 		public QueryRunner(Query<T> query) {
+			//TODO TEH
+			super(ThrowExceptionHandler.getInstance());
 			this.query = query;
 		}
 
 		@Override
-		public void run() {
+		protected void runAt() {
 			result = query.get();
 			synchronized (this) {
@@ -206,7 +199,7 @@
 	public static <C> void synchronize(Dispatcher<C> dispatcher, double seconds) {
 		final Waiter waiter = new Waiter(seconds);
-		dispatcher.dispatch(new RunAt<C>() {
+		dispatcher.dispatch(new RunAt<C>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				waiter.pass();
 			}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Future.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 97)
@@ -7,14 +7,4 @@
  */
 public abstract class Future<T> implements ExceptionResultHandler {
-
-	protected final ExceptionResultHandler handler;
-
-	public Future(ExceptionResultHandler handler) {
-		this.handler = handler;
-	}
-
-	public Future() {
-		this.handler = null;
-	}
 
 	protected abstract void result(T result);
@@ -28,19 +18,4 @@
 	}
 
-	public static <T> void passOrHandle(Future<T> future, T value, FramsticksException e) {
-		if (e != null) {
-			future.handle(e);
-		} else {
-			future.pass(value);
-		}
-	}
 
-	@Override
-	public void handle(FramsticksException exception) {
-		if (handler != null) {
-			handler.handle(exception);
-			return;
-		}
-		throw exception;
-	}
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java	(revision 97)
@@ -0,0 +1,19 @@
+package com.framsticks.util.dispatching;
+
+import com.framsticks.util.FramsticksException;
+
+public abstract class FutureHandler<T> extends Future<T> {
+
+	protected final ExceptionResultHandler handler;
+
+	public FutureHandler(ExceptionResultHandler handler) {
+		assert handler != null;
+		this.handler = handler;
+	}
+
+	@Override
+	public final void handle(FramsticksException exception) {
+		handler.handle(exception);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 97)
@@ -1,4 +1,6 @@
 package com.framsticks.util.dispatching;
 
+import java.util.AbstractCollection;
+import java.util.Collection;
 import java.util.Collections;
 import java.util.HashSet;
@@ -42,4 +44,19 @@
 		if (this.state.equals(JoinableState.RUNNING)) {
 			Dispatching.use(joinable, this);
+		}
+	}
+
+	public synchronized void remove(T joinable) {
+		if (this.state.ordinal() > JoinableState.RUNNING.ordinal()) {
+			throw new FramsticksException().msg("failed to remote joinable - collection is passed running state").arg("joinable", joinable).arg("collection", this);
+		}
+		if (!joinables.contains(joinable)) {
+			throw new FramsticksException().msg("joinable is not observed").arg("joinable", joinable).arg("in", this);
+		}
+
+		joinables.remove(joinable);
+
+		if (this.state.equals(JoinableState.RUNNING)) {
+			Dispatching.drop(joinable, this);
 		}
 	}
@@ -140,3 +157,31 @@
 	}
 
+	public Collection<T> asCollection() {
+		return new AbstractCollection<T>() {
+
+			@Override
+			public Iterator<T> iterator() {
+				return JoinableCollection.this.iterator();
+			}
+
+			@Override
+			public int size() {
+				return JoinableCollection.this.size();
+			}
+
+			@Override
+			public boolean add(T joinable) {
+				JoinableCollection.this.add(joinable);
+				return true;
+			}
+
+			@SuppressWarnings("unchecked")
+			@Override
+			public boolean remove(Object joinable) {
+				JoinableCollection.this.remove((T) joinable);
+				return true;
+			}
+		};
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 97)
@@ -1,11 +1,31 @@
 package com.framsticks.util.dispatching;
 
-public abstract class RunAt<C> implements java.lang.Runnable {
+import com.framsticks.util.FramsticksException;
 
-	public RunAt() {
+public abstract class RunAt<C> implements ExceptionResultHandler, Runnable {
+
+	protected final ExceptionResultHandler handler;
+
+	public RunAt(ExceptionResultHandler handler) {
+		assert handler != null;
+		this.handler = handler;
 	}
 
-	public RunAt(Dispatcher<? super C> dispatcher) {
-		dispatcher.dispatch(this);
+	protected abstract void runAt();
+
+	public final void run() {
+		try {
+			runAt();
+		} catch (FramsticksException e) {
+			handle(e);
+		}
 	}
+
+
+
+	@Override
+	public final void handle(FramsticksException exception) {
+		handler.handle(exception);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/Task.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 97)
@@ -8,9 +8,11 @@
 	protected final long moment;
 
-	public Task() {
+	public Task(ExceptionResultHandler handler) {
+		super(handler);
 		moment = System.currentTimeMillis();
 	}
 
-	public Task(long moment) {
+	public Task(ExceptionResultHandler handler, long moment) {
+		super(handler);
 		this.moment = System.currentTimeMillis() + moment;
 	}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 97)
@@ -15,5 +15,5 @@
 public class Thread<C> extends AbstractJoinable implements Dispatcher<C> {
 
-	private static final Logger log = Logger.getLogger(Thread.class.getName());
+	private static final Logger log = Logger.getLogger(Thread.class);
 
 	protected final java.lang.Thread thread;
@@ -73,5 +73,5 @@
 			}
 			try {
-				task.run();
+				task.runAt();
 			} catch (Exception e) {
 				if (exceptionHandler != null) {
@@ -119,8 +119,8 @@
 	public void dispatch(final RunAt<? extends C> runnable) {
 		if (!(runnable instanceof Task)) {
-			enqueueTask(new Task<C>() {
+			enqueueTask(new Task<C>(runnable) {
 				@Override
-				public void run() {
-					runnable.run();
+				protected void runAt() {
+					runnable.runAt();
 				}
 			});
